/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.buff.continual.ConstantlyBuffConfig
 */
package fire.pb.buff;

import fire.pb.buff.Module;
import fire.pb.buff.continual.ConstantlyBuffConfig;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class BuffClashs {
    private final int buffId;
    private final String buffName;
    private int defaultClashMsgId = 0;
    private final List<Integer> clashStates = new LinkedList<Integer>();
    private final List<Integer> clashBuffs = new LinkedList<Integer>();
    private final List<Integer> coverBuffs = new LinkedList<Integer>();
    private final List<Integer> invalidBuffs = new LinkedList<Integer>();
    private final Map<Integer, Integer> clashMsgIds = new HashMap<Integer, Integer>();
    private final Set<Integer> clashMapIds = new HashSet<Integer>();

    public BuffClashs(int buffId, String name) {
        this.buffId = buffId;
        this.buffName = name;
    }

    public int getBuffId() {
        return this.buffId;
    }

    public void addClashBuff(ConstantlyBuffConfig conf) {
        if (conf == null || conf.getClassName() == null) {
            Module.logger.error((Object)("error：添加冲突buff时找不到该buff配置或者buff类名为空. BuffID = " + this.buffId));
            return;
        }
        if (conf.getClassName().equals("fire.pb.buff.continual.NullBuff")) {
            this.clashStates.add(conf.getBuffTypeId());
        } else {
            this.clashBuffs.add(conf.getBuffTypeId());
        }
    }

    public List<Integer> getClashStates() {
        return this.clashStates;
    }

    public List<Integer> getClashBuffs() {
        return this.clashBuffs;
    }

    public List<Integer> getOverrideBuffs() {
        return this.coverBuffs;
    }

    public int getDefaultClashMsgId() {
        return this.defaultClashMsgId;
    }

    public void setDefaultClashMsgId(int defaultClashMsgId) {
        this.defaultClashMsgId = defaultClashMsgId;
    }

    public Map<Integer, Integer> getClashMsgIds() {
        return this.clashMsgIds;
    }

    public int checkStateClash(long roleId) {
        for (int buffId : this.clashStates) {
            if (!Module.existState(roleId, buffId)) continue;
            return buffId;
        }
        return 0;
    }

    public int checkBuffClash(Set<Integer> buffIds) {
        for (int id : buffIds) {
            int bufftype = Module.getInstance().getDefaultCBuffConfig(id).getBuffType();
            for (int clash : this.clashBuffs) {
                if (!(clash >= 1000 ? clash == id : (clash >= 100 ? clash == bufftype : (clash >= 10 ? clash == bufftype / 10 : clash >= 1 && clash == bufftype / 100)))) continue;
                return id;
            }
        }
        return 0;
    }

    public int checkBuffInvalid(Set<Integer> buffIds) {
        for (int id : buffIds) {
            int bufftype = Module.getInstance().getDefaultCBuffConfig(id).getBuffType();
            for (int invalid : this.invalidBuffs) {
                if (!(invalid >= 1000 ? invalid == id : (invalid >= 100 ? invalid == bufftype : (invalid >= 10 ? invalid == bufftype / 10 : invalid >= 1 && invalid == bufftype / 100)))) continue;
                return id;
            }
        }
        return 0;
    }

    public List<Integer> getOverridedBuffIds(Set<Integer> buffIds) {
        ArrayList<Integer> rmbuffs = new ArrayList<Integer>();
        for (int id : buffIds) {
            int bufftype = Module.getInstance().getDefaultCBuffConfig(id).getBuffType();
            for (int override : this.coverBuffs) {
                if (override >= 1000) {
                    if (override != id) continue;
                    rmbuffs.add(id);
                    continue;
                }
                if (override >= 100) {
                    if (override != bufftype) continue;
                    rmbuffs.add(id);
                    continue;
                }
                if (override >= 10) {
                    if (override != bufftype / 10) continue;
                    rmbuffs.add(id);
                    continue;
                }
                if (override < 1 || override != bufftype / 100) continue;
                rmbuffs.add(id);
            }
        }
        return rmbuffs;
    }

    public String getName() {
        return this.buffName;
    }

    public List<Integer> getInvalidBuffs() {
        return this.invalidBuffs;
    }

    public Set<Integer> getClashMapIds() {
        return this.clashMapIds;
    }

    public boolean checkMapClash(int mapId) {
        return this.clashMapIds.contains(mapId);
    }
}

